package com.dashitech;

import org.springframework.boot.SpringApplication;
import org.springframework.boot.autoconfigure.SpringBootApplication;
import org.springframework.context.annotation.ComponentScan;
import org.springframework.context.annotation.ImportResource;
import org.springframework.context.annotation.PropertySource;
import org.springframework.scheduling.annotation.EnableAsync;
import org.springframework.scheduling.annotation.EnableScheduling;

import java.text.SimpleDateFormat;
import java.util.Date;



@SpringBootApplication
@EnableAsync
@EnableScheduling
@ComponentScan(basePackages = {"com.dashitech"})
@PropertySource({"classpath:application-custom.properties", "application.properties"})
@ImportResource(locations = "classpath*:/application-context.xml")
//@Import({DynamicDataSourceRegister.class}) // 注册动态多数据源
//@MapperScan("com.dashitech.dao.mysqldb1")//将项目中对应的mapper类的路径加进来就可以了
//@EnableAutoConfiguration(exclude = {DataSourceAutoConfiguration.class, HibernateJpaAutoConfiguration.class})    //不连数据库
public class Application {

    public static void main(String[] args) {
        SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");
        System.out.println("hsmsV1>>>>>>>>>>>>>>>>>>startData" + sdf.format(new Date()));
        SpringApplication.run(Application.class, args);
    }


}
