
package com.dashitech.config;

import org.springframework.beans.factory.annotation.Qualifier;
import org.springframework.boot.autoconfigure.jdbc.DataSourceBuilder;
import org.springframework.boot.context.properties.ConfigurationProperties;
import org.springframework.context.annotation.Bean;
import org.springframework.context.annotation.Configuration;
import org.springframework.context.annotation.Primary;

import javax.sql.DataSource;


/**
 * Created by chi on 2019/9/20.
 */

@Configuration
public class DataSourceConfig {

    /**
     *  数据源2
     */
    @Primary
    @Bean(name = "mysql2DataSource")
    @Qualifier(value = "mysql2DataSource")
    @ConfigurationProperties(prefix = "mysql2.spring.datasource")
    public DataSource mysql2DataSource(){
        return DataSourceBuilder.create().build();
    }


    /**
     *  数据源3
     */

    @Bean(name = "mysql3DataSource")
    @Qualifier(value = "mysql3DataSource")
    @ConfigurationProperties(prefix = "mysql3.spring.datasource")
    public DataSource mysql3DataSource(){
        return DataSourceBuilder.create().build();
    }

}

