package com.dashitech.migration;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Qualifier;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.jdbc.core.JdbcTemplate;

import java.util.List;
import java.util.Map;

/**
 * Created by CX on 2024/10/10.
 */
public abstract class BaseTask implements SqlTask {

    @Value("${application.name}")
    protected String appName;

    @Autowired
    @Qualifier("jdbcTemplateHsms")
    protected JdbcTemplate jdbcTemplateHsms;

    @Autowired
    @Qualifier("jdbcTemplateMdv2")
    protected JdbcTemplate jdbcTemplateMdv2;

    /**
     * 获取字典id
     */
    public Long getDicId(JdbcTemplate jt,String key, String value) {
        List<Map<String,Object>> list = jt.queryForList("SELECT id from itsm_base_dictionary WHERE _key = ? and _value = ?",key,value);
        if(list != null && list.size() > 0) {
            Object obj = list.get(0).get("id");
            return obj == null ? null : Long.valueOf(obj.toString());
        }
        return null;
    }

    public Object getSingleObj(JdbcTemplate jt,String sql, Object... args) {
        List<Map<String,Object>> list = jt.queryForList(sql,args);
        if(list != null && list.size() > 0) {
            Map<String, Object> map = list.get(0);
            for (Map.Entry<String, Object> entry : map.entrySet()) {
                return entry.getValue();
            }
        }
        return null;
    }

}
