package com.dashitech.migration.core;

import java.io.Serializable;
import java.util.HashMap;
import java.util.Map;

/**
 * 数据匹配器
 */
public class DataMapper implements Serializable{

    //目标
    private String targetName;
    private Object targetValue;
    private Long targetId;

    //源
    private String sourceName;
    private Object sourceValue;
    private Long sourceId;

    //操作类型
    private boolean remove = false;
    private boolean update = false;
    private boolean add = false;
    private boolean replace = false;

    /**
     * 匹配完成后的id对照，source:target
     */
    private Map<Long, Long> idCache = new HashMap<>();

    public DataMapper() {
    }

    public DataMapper(String targetName, String sourceName) {
        this.targetName = targetName;
        this.sourceName = sourceName;
    }

    public boolean isAdd() {
        return add;
    }

    public void setAdd(boolean add) {
        this.add = add;
    }

    public boolean isReplace() {
        return replace;
    }

    public void setReplace(boolean replace) {
        this.replace = replace;
    }

    public Map<Long, Long> getIdCache() {
        return idCache;
    }

    public void setIdCache(Map<Long, Long> idCache) {
        this.idCache = idCache;
    }

    public boolean isRemove() {
        return remove;
    }

    public void setRemove(boolean remove) {
        this.remove = remove;
    }

    public boolean isUpdate() {
        return update;
    }

    public void setUpdate(boolean update) {
        this.update = update;
    }

    public String getTargetName() {
        return targetName;
    }

    public void setTargetName(String targetName) {
        this.targetName = targetName;
    }

    public Object getTargetValue() {
        return targetValue;
    }

    public void setTargetValue(Object targetValue) {
        this.targetValue = targetValue;
    }

    public Long getTargetId() {
        return targetId;
    }

    public void setTargetId(Long targetId) {
        this.targetId = targetId;
    }

    public String getSourceName() {
        return sourceName;
    }

    public void setSourceName(String sourceName) {
        this.sourceName = sourceName;
    }

    public Object getSourceValue() {
        return sourceValue;
    }

    public void setSourceValue(Object sourceValue) {
        this.sourceValue = sourceValue;
    }

    public Long getSourceId() {
        return sourceId;
    }

    public void setSourceId(Long sourceId) {
        this.sourceId = sourceId;
    }

}
