package com.dashitech.migration.task.call;

import com.dashitech.migration.BaseTask;
import com.dashitech.migration.core.FieldMapper;
import com.dashitech.migration.util.JdbcUtil;
import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import org.springframework.stereotype.Component;
import org.springframework.transaction.annotation.Transactional;

import java.util.List;
import java.util.Map;

/**
 * @author song
 * @date 2024年10月12日
 */
@Component
public class CallLogTask extends BaseTask {

    public static Log log = LogFactory.getLog(CallLogTask.class);

    @Override
    @Transactional(rollbackFor = Exception.class)
    public void start() {
        log.info("通话记录callLog转换开始");

        StringBuffer sql = new StringBuffer("SELECT version,call_accept,caller_id_number as DTMFA,destination_number as DTMFB,created_time as response_time,");
        sql.append("gate_way as phyIDA,recording_file_name as _path,call_type,is_answered as call_state,branch_id as hos_id,");
        sql.append("if(calltime is null,if(is_answered=1,TIMESTAMPDIFF(MINUTE,created_time,over_time),null),calltime) as long_time FROM itsm_call_record");
        List<Map<String, Object>> callLogList = jdbcTemplateMdv2.queryForList(sql.toString());

        FieldMapper mapper = new FieldMapper();
        mapper.trans2JdbcRow(callLogList);

        JdbcUtil jdbcUtil = new JdbcUtil(jdbcTemplateHsms);
        jdbcUtil.batchPageInsert("itsm_call_log", mapper.getRows());

        mapper.clear();
    }

    @Override
    public FieldMapper loadCache() {
        return null;
    }
}
