package com.dashitech.migration.task.call;

import com.dashitech.migration.BaseTask;
import com.dashitech.migration.core.FieldMapper;
import com.dashitech.migration.util.JdbcUtil;
import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import org.springframework.stereotype.Component;
import org.springframework.transaction.annotation.Transactional;

import java.util.List;
import java.util.Map;

/**
 * @author song
 * @date 2024年10月12日
 */

@Component
public class HjzxRecordTask extends BaseTask {

    public static Log log = LogFactory.getLog(HjzxRecordTask.class);
    @Override
    @Transactional(rollbackFor = Exception.class)
    public void start() {
        log.info("呼叫中心HjzxRecord转换开始");

        StringBuffer sql = new StringBuffer(" select * from itsm_hjzx_record");
        List<Map<String, Object>> hjzxList = jdbcTemplateMdv2.queryForList(sql.toString());

        FieldMapper mapper = new FieldMapper();
        mapper.addOperationRemove("id");
        mapper.addOperationUpdate("hos_id", "branch_id");
        mapper.trans2JdbcRow(hjzxList);

        JdbcUtil jdbcUtil = new JdbcUtil(jdbcTemplateHsms);
        jdbcUtil.batchPageInsert("itsm_hjzx_record", mapper.getRows());

        mapper.clear();
    }

    @Override
    public FieldMapper loadCache() {
        return null;
    }
}
