package com.dashitech.migration.task.category;

import com.dashitech.migration.BaseTask;
import com.dashitech.migration.core.FieldMapper;
import com.dashitech.migration.util.JdbcUtil;
import org.apache.commons.collections.CollectionUtils;
import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import org.springframework.stereotype.Component;
import org.springframework.transaction.annotation.Transactional;

import java.util.List;
import java.util.Map;

/**
 * @author song
 * @date 2024年10月12日
 */
@Component
public class IncidentCategoryConfigTask extends BaseTask {

    public static Log log = LogFactory.getLog(IncidentCategoryConfigTask.class);
    @Override
    @Transactional(rollbackFor = Exception.class)
    public void start() {
        StringBuffer sql = new StringBuffer("SELECT a.version,a.category_id,b._priority as priority,a.duty_id,a.branch_user_group_type as user_group,a.group_id,");
        sql.append("a.user_id,NOW() as add_time,a.branch_id as hos_id FROM itsm_incident_category_usergroup a ");
        sql.append(" JOIN itsm_incident_category b ON a.category_id = b.id");
        if ("xiangyang".equals(appName)) {
            sql.append(" WHERE a.branch_id <> 4 ");
        }
        List<Map<String, Object>> categoryConfigList = jdbcTemplateMdv2.queryForList(sql.toString());
        FieldMapper mapper = new FieldMapper();
        if (CollectionUtils.isNotEmpty(categoryConfigList)) {
            mapper.addOperationAdd("score", getDicId(jdbcTemplateHsms,"incident_score","1"));
            mapper.trans2JdbcRow(categoryConfigList);

            JdbcUtil jdbcUtil = new JdbcUtil(jdbcTemplateHsms);
            jdbcUtil.batchPageInsert("itsm_itsm_incident_category_config", mapper.getRows());
        }
        mapper.clear();
    }

    @Override
    public FieldMapper loadCache() {
        return null;
    }
}
