package com.dashitech.migration.task.category;

import com.dashitech.migration.BaseTask;
import com.dashitech.migration.core.FieldMapper;
import com.dashitech.migration.util.JdbcUtil;
import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import org.springframework.stereotype.Component;
import org.springframework.transaction.annotation.Transactional;

import java.util.List;
import java.util.Map;

/**
 * @author song
 * @date 2024年10月12日
 */
@Component
public class IncidentCategoryTask extends BaseTask {

    public static Log log = LogFactory.getLog(IncidentCategoryTask.class);
    @Override
    @Transactional(rollbackFor = Exception.class)
    public void start() {
        StringBuffer sql = new StringBuffer("SELECT id,version,category,parentid as parent,delete_flag,quanPinyin as qp,suoPinyin as jp,now() as add_time,");
        sql.append("hierarchy,muti_category,muti_suoPinyin as muti_jp,muti_quanPinyin as muti_qp,IFNULL(branch_id,1) as hos_id ");
        sql.append(" FROM itsm_incident_category ");
        List<Map<String, Object>> categoryList = jdbcTemplateMdv2.queryForList(sql.toString());

        FieldMapper mapper = new FieldMapper();
        mapper.trans2JdbcRow(categoryList);

        JdbcUtil jdbcUtil = new JdbcUtil(jdbcTemplateHsms);
        jdbcUtil.batchPageInsert("itsm_itsm_incident_category", mapper.getRows());

        mapper.clear();
    }

    @Override
    public FieldMapper loadCache() {
        return null;
    }
}
