package com.dashitech.migration.task.consumable;

import com.dashitech.migration.BaseTask;
import com.dashitech.migration.core.FieldMapper;
import com.dashitech.migration.task.uc.DepartmentTask;
import com.dashitech.migration.task.uc.HospitalTask;
import com.dashitech.migration.task.uc.UserTask;
import com.dashitech.migration.util.JdbcUtil;
import org.apache.commons.collections.CollectionUtils;
import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;
import org.springframework.transaction.annotation.Transactional;

import java.util.List;
import java.util.Map;

/**
 * @author song
 * @date 2024年10月12日
 */
@Component
public class ConsumableHistoryTask extends BaseTask {

    public static Log log = LogFactory.getLog(ConsumableHistoryTask.class);

    @Autowired
    private HospitalTask hospitalTask;

    @Autowired
    private UserTask userTask;

    @Autowired
    private DepartmentTask departmentTask;

    @Override
    @Transactional(rollbackFor = Exception.class)
    public void start() {
        log.info("耗材日志ConsumableHistoryTask转换开始");

        StringBuffer sql = new StringBuffer("SELECT id,asset_consumables_id,operator,VERSION,time,motion,source,source_id,type,consumables_sum,_description,");
        sql.append("_version_number,_details,extra1,extra2,spd_code,consume_type,consume_source,use_dept,his_id,incident_id,repair_summary_id,summary_id,");
        if ("xiangyang".equals(appName)) {
            sql.append("if(repair_duty=4,10,repair_duty) as repair_duty,IF(branch_id=4,3,branch_id) as hos_id ");
        } else {
            sql.append("repair_duty,branch_id as 'hos_id' ");
        }
        sql.append(" FROM itsm_asset_consumables_history ");
        List<Map<String, Object>> consumableHistoryList = jdbcTemplateMdv2.queryForList(sql.toString());
        FieldMapper mapper = new FieldMapper();
        if (CollectionUtils.isNotEmpty(consumableHistoryList)) {
            mapper.addOperationReplace("repair_duty", hospitalTask.loadCache().getIdCache());
            mapper.addOperationReplace("operator", userTask.loadCache().getIdCache());
            if ("xiangyang".equals(appName)) {
                mapper.addOperationReplace("use_dept", departmentTask.loadCache().getIdCache());
            }
            mapper.trans2JdbcRow(consumableHistoryList);

            JdbcUtil jdbcUtil = new JdbcUtil(jdbcTemplateHsms);
            jdbcUtil.batchPageInsert("itsm_itsm_asset_consumables_history", mapper.getRows());
        }


        mapper.clear();

    }

    @Override
    public FieldMapper loadCache() {
        return null;
    }
}
