package com.dashitech.migration.task.consumable;

import com.dashitech.migration.BaseTask;
import com.dashitech.migration.core.FieldMapper;
import com.dashitech.migration.task.uc.CompanyTask;
import com.dashitech.migration.task.uc.HospitalTask;
import com.dashitech.migration.util.JdbcUtil;
import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;
import org.springframework.transaction.annotation.Transactional;

import java.util.List;
import java.util.Map;

/**
 * @author song
 * @date 2024年10月12日
 */
@Component
public class ConsumableTask extends BaseTask {

    public static Log log = LogFactory.getLog(ConsumableTask.class);

    @Autowired
    private HospitalTask hospitalTask;

    @Autowired
    private CompanyTask companyTask;

    @Override
    @Transactional(rollbackFor = Exception.class)
    public void start() {
        log.info("耗材ConsumableTask转换开始");
        StringBuffer sql = new StringBuffer("SELECT id,version,NAME,brand_model as model,inventory_num as stock,start_price as price,company_ids as supplier_id,");
        sql.append("delete_flag,unit,IFNULL(spd_code,spdcode) as spd_code,duty_id as hos_id FROM itsm_asset_consumable");
        List<Map<String, Object>> consumableList = jdbcTemplateMdv2.queryForList(sql.toString());
        FieldMapper mapper = new FieldMapper();
        mapper.addOperationReplace("hos_id", hospitalTask.loadCache().getIdCache());
        mapper.addOperationReplace("supplier_id", companyTask.loadCache().getIdCache());
        mapper.trans2JdbcRow(consumableList);

        JdbcUtil jdbcUtil = new JdbcUtil(jdbcTemplateHsms);
        jdbcUtil.batchPageInsert("itsm_itsm_consumable", mapper.getRows());

        mapper.clear();

    }

    @Override
    public FieldMapper loadCache() {
        return null;
    }
}
