package com.dashitech.migration.task.consumable;

import com.dashitech.migration.BaseTask;
import com.dashitech.migration.core.FieldMapper;
import com.dashitech.migration.util.JdbcUtil;
import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import org.springframework.stereotype.Component;
import org.springframework.transaction.annotation.Transactional;

import java.util.List;
import java.util.Map;

/**
 * @author song
 * @date 2024年10月14日
 */
@Component
public class RepairSummaryTask extends BaseTask {

    public static Log log = LogFactory.getLog(RepairSummaryTask.class);
    @Override
    @Transactional(rollbackFor = Exception.class)
    public void start() {
        log.info("汇总单数据RepairSummaryTask开始转换");
        StringBuffer sql = new StringBuffer("select * from itsm_repair_summary");
        List<Map<String, Object>> repairSummaryList = jdbcTemplateMdv2.queryForList(sql.toString());
        FieldMapper mapper = new FieldMapper();
        mapper.trans2JdbcRow(repairSummaryList);

        JdbcUtil jdbcUtil = new JdbcUtil(jdbcTemplateHsms);
        jdbcUtil.batchPageInsert("itsm_itsm_repair_summary", mapper.getRows());

        mapper.clear();
    }

    @Override
    public FieldMapper loadCache() {
        return null;
    }
}
