package com.dashitech.migration.task.consumable;

import com.dashitech.migration.BaseTask;
import com.dashitech.migration.core.FieldMapper;
import com.dashitech.migration.util.JdbcUtil;
import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import org.springframework.stereotype.Component;
import org.springframework.transaction.annotation.Transactional;

import java.util.List;
import java.util.Map;

/**
 * @author song
 * @date 2024年10月12日
 */
@Component
public class SummaryConsumableTask extends BaseTask {

    public static Log log = LogFactory.getLog(SummaryConsumableTask.class);
    @Override
    @Transactional(rollbackFor = Exception.class)
    public void start() {
        log.info("汇总单耗材数据SummaryConsumableTask转换开始");
        StringBuffer sql = new StringBuffer("SELECT * from itsm_summary_consumables");
        List<Map<String, Object>> summaryConsuableList = jdbcTemplateMdv2.queryForList(sql.toString());
        FieldMapper mapper = new FieldMapper();
        mapper.trans2JdbcRow(summaryConsuableList);

        JdbcUtil jdbcUtil = new JdbcUtil(jdbcTemplateHsms);
        jdbcUtil.batchPageInsert("itsm_itsm_summary_consumables", mapper.getRows());

        mapper.clear();

    }

    @Override
    public FieldMapper loadCache() {
        return null;
    }
}
