package com.dashitech.migration.task.incident;

import com.dashitech.migration.BaseTask;
import com.dashitech.migration.SqlTask;
import com.dashitech.migration.core.DataMigrationter;
import com.dashitech.migration.core.FieldMapper;
import com.dashitech.migration.util.JdbcUtil;
import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.core.annotation.Order;
import org.springframework.stereotype.Component;
import org.springframework.transaction.annotation.Transactional;

import java.util.List;
import java.util.Map;

/**
 * Created by CX on 2024/10/10.
 */
@Component
public class IncidentSynergeticTask extends BaseTask {

    @Autowired
    SqlTask hospitalTask;
    @Autowired
    SqlTask userTask;

    public static Log log = LogFactory.getLog(IncidentSynergeticTask.class);

    @Override
    @Transactional(rollbackFor = Exception.class)
    public void start() {
        log.info(" *** IncidentSynergeticTask start 开始 *** ");

        StringBuffer sb = new StringBuffer();
        sb.append(" select * from itsm_incident_synergetic ");

        List list = jdbcTemplateMdv2.queryForList(sb.toString());

        FieldMapper mapper = new FieldMapper();
        mapper.addOperationUpdate("hos_id", "branch_id");
        mapper.addOperationReplace("user_id", userTask.loadCache().getIdCache());
        mapper.addOperationReplace("duty_id", hospitalTask.loadCache().getIdCache());
        mapper.trans2JdbcRow(list);

        JdbcUtil jdbcUtil = new JdbcUtil(jdbcTemplateHsms);
        jdbcUtil.batchPageInsert("itsm_itsm_incident_synergetic", mapper.getRows());

        //clear释放内存
        mapper.clear();
    }

    @Override
    public FieldMapper loadCache() {
        log.info(" *** IncidentSynergeticTask loadCache 开始 *** ");


        return null;
    }
}
