package com.dashitech.migration.task.other;

import com.dashitech.migration.BaseTask;
import com.dashitech.migration.core.FieldMapper;
import com.dashitech.migration.util.JdbcUtil;
import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import org.springframework.stereotype.Component;
import org.springframework.transaction.annotation.Transactional;

import java.util.List;
import java.util.Map;

/**
 * Created by CX on 2024/10/10.
 */
@Component
public class TokenTask extends BaseTask {

    public static Log log = LogFactory.getLog(TokenTask.class);

    @Override
    @Transactional(rollbackFor = Exception.class)
    public void start() {
        log.info(" *** TokenTask start开始 *** ");
        StringBuffer sql = new StringBuffer("select * from itsm_base_token");
        List<Map<String, Object>> tokenList = jdbcTemplateMdv2.queryForList(sql.toString());

        FieldMapper mapper = new FieldMapper();
        mapper.addOperationRemove("id");
        mapper.trans2JdbcRow(tokenList);

        JdbcUtil jdbcUtil = new JdbcUtil(jdbcTemplateHsms);
        jdbcUtil.batchPageInsert("itsm_base_token", mapper.getRows());

        //clear释放内存
        mapper.clear();
    }

    @Override
    public FieldMapper loadCache() {
        log.info(" *** AttachmentTask loadCache开始 *** ");
        FieldMapper mapper = new FieldMapper();


        return mapper;
    }


}
