package com.dashitech.migration.task.uc;

import com.dashitech.migration.BaseTask;
import com.dashitech.migration.core.DataMigrationter;
import com.dashitech.migration.core.FieldMapper;
import com.dashitech.migration.core.RowsWrap;
import com.dashitech.migration.util.JdbcUtil;
import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import org.springframework.stereotype.Component;
import org.springframework.transaction.annotation.Transactional;

import java.util.List;
import java.util.Map;

/**
 * @author song
 * @date 2024年10月14日
 */
@Component
public class AreaTask extends BaseTask {

    public static Log log = LogFactory.getLog(AreaTask.class);

    @Override
    @Transactional(rollbackFor = Exception.class)
    public void start() {
        if ("xiangyang".equals(appName)) {
            log.info(" *** 楼栋AreaTask转换开始 *** ");
            StringBuffer sql = new StringBuffer("select 0 as version,IF(branch_id=4,3,branch_id) as hos_id,area as building_name,now() as operator_time, ");
            sql.append(" delete_flag as _delete from itsm_uc_area");
            List<Map<String, Object>> areaList = jdbcTemplateMdv2.queryForList(sql.toString());
            FieldMapper mapper = new FieldMapper();
            mapper.trans2JdbcRow(areaList);

            FieldMapper areaMapper = this.loadCache();
            RowsWrap rw = DataMigrationter.getRowsWrap(mapper,areaMapper);
            JdbcUtil jdbcUtil = new JdbcUtil(jdbcTemplateHsms);
            //科室只做更新 已有的科室不做处理
            jdbcUtil.batchPageInsert("itsm_uc_building", rw.getInsertRows());

            mapper.clear();
        }

    }

    @Override
    public FieldMapper loadCache() {
        log.info(" *** 加载楼栋area缓存 *** ");
        StringBuffer sql = new StringBuffer("select id,hos_id,building_name from itsm_uc_building ");
        List<Map<String, Object>> buildingList = jdbcTemplateHsms.queryForList(sql.toString());
        sql = new StringBuffer("select id,IF(branch_id=4,3,branch_id) as hos_id,area as building_name  from itsm_uc_area ");
        List<Map<String, Object>> areaList = jdbcTemplateMdv2.queryForList(sql.toString());

        FieldMapper mapper = new FieldMapper();
        mapper.addFieldMapper("building_name", "building_name");
        mapper.addFieldMapper("hos_id", "hos_id");

        DataMigrationter.loadCache(buildingList, areaList, mapper);

        return mapper;
    }
}
