package com.dashitech.migration.task.uc;

import com.dashitech.migration.BaseTask;
import com.dashitech.migration.core.FieldMapper;
import com.dashitech.migration.util.JdbcUtil;
import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import org.springframework.stereotype.Component;
import org.springframework.transaction.annotation.Transactional;

import java.util.List;
import java.util.Map;

/**
 * 必须在HospitalTask转后执行
 * Created by CX on 2024/10/10.
 */
@Component
public class HospitalConfigTask extends BaseTask {

    public static Log log = LogFactory.getLog(HospitalConfigTask.class);

    @Override
    @Transactional(rollbackFor = Exception.class)
    public void start() {
        log.info(" *** HospitalConfigTask start开始 *** ");
        //查询维修科室 院区和院区配置def表笛卡尔积数据
        StringBuffer sql = new StringBuffer("SELECT 0 AS version,b._key,b._value,b._value2,b._value3,");
        sql.append("b._value4,b._desc,b._orders,b._active,b.id AS def_id,a.id AS hos_id, b.model as model");
        sql.append(" FROM itsm_uc_hospital a JOIN itsm_system_hospital_config_def b where a.delete_flag = 0 ");
        sql.append(" and a.type = (select id from itsm_base_dictionary where _key = 'hospital_type' and _value = '6') ");
        List<Map<String, Object>> hosConfigList = jdbcTemplateHsms.queryForList(sql.toString());
        FieldMapper mapper = new FieldMapper();
        mapper.trans2JdbcRow(hosConfigList);

        JdbcUtil jdbcUtil = new JdbcUtil(jdbcTemplateHsms);
        jdbcUtil.batchPageInsert("itsm_system_hospital_config", mapper.getRows());

        //clear释放内存
        mapper.clear();
    }

    @Override
    public FieldMapper loadCache() {
        log.info(" *** HospitalConfigTask loadCache开始 *** ");
        FieldMapper mapper = new FieldMapper();


        return mapper;
    }


}
