package com.dashitech.migration.task.uc;

import com.dashitech.migration.BaseTask;
import com.dashitech.migration.core.DataMigrationter;
import com.dashitech.migration.core.FieldMapper;
import com.dashitech.migration.core.RowsWrap;
import com.dashitech.migration.util.JdbcUtil;
import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;
import org.springframework.transaction.annotation.Transactional;

import java.util.List;
import java.util.Map;

/**
 * @author song
 * @date 2024年10月14日
 */
@Component
public class PlaceTask extends BaseTask {

    public static Log log = LogFactory.getLog(PlaceTask.class);

    @Autowired
    private AreaTask areaTask;

    @Override
    @Transactional(rollbackFor = Exception.class)
    public void start() {
        if ("xiangyang".equals(appName)) {
            log.info(" *** 楼层PlaceTask转换开始 *** ");
            StringBuffer sql = new StringBuffer("select 0 as version,area_id as build_id,SUBSTRING_INDEX(SUBSTRING_INDEX(place,'楼',1),'号',1) as floor_name,IF(branch_id=4,3,branch_id) as hos_id,now() as operator_time, ");
            sql.append(" delete_flag as _delete from itsm_uc_place");
            List<Map<String, Object>> placeList = jdbcTemplateMdv2.queryForList(sql.toString());
            FieldMapper mapper = new FieldMapper();
            mapper.addOperationReplace("build_id", areaTask.loadCache().getIdCache());
            mapper.trans2JdbcRow(placeList);

            FieldMapper areaMapper = this.loadCache();
            RowsWrap rw = DataMigrationter.getRowsWrap(mapper,areaMapper);
            JdbcUtil jdbcUtil = new JdbcUtil(jdbcTemplateHsms);
            //科室只做更新 已有的科室不做处理
            jdbcUtil.batchPageInsert("itsm_uc_floor", rw.getInsertRows());
        }
    }

    @Override
    public FieldMapper loadCache() {
        log.info(" *** 加载楼层place缓存 *** ");
        StringBuffer sql = new StringBuffer("select id,hos_id,build_id,floor_name from itsm_uc_floor ");
        List<Map<String, Object>> floorList = jdbcTemplateHsms.queryForList(sql.toString());
        sql = new StringBuffer("select id,IF(branch_id=4,3,branch_id) as hos_id,area_id as build_id,SUBSTRING_INDEX(SUBSTRING_INDEX(place,'楼',1),'号',1) as floor_name from itsm_uc_place ");
        List<Map<String, Object>> placeList = jdbcTemplateMdv2.queryForList(sql.toString());

        FieldMapper mapper = new FieldMapper();
        mapper.addFieldMapper("floor_name", "floor_name");
        mapper.addFieldMapper("build_id", "build_id");
        mapper.addFieldMapper("hos_id", "hos_id");

        DataMigrationter.loadCache(floorList, placeList, mapper);

        return mapper;
    }
}
