package com.dashitech.migration.task.uc;

import com.dashitech.migration.BaseTask;
import com.dashitech.migration.SqlTask;
import com.dashitech.migration.core.FieldMapper;
import com.dashitech.migration.util.JdbcUtil;
import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;
import org.springframework.transaction.annotation.Transactional;

import java.util.List;

/**
 * Created by CX on 2024/10/10.
 */
@Component
public class RoleUserTask extends BaseTask {

    public static Log log = LogFactory.getLog(RoleUserTask.class);

    @Autowired
    SqlTask userTask;

    @Override
    @Transactional(rollbackFor = Exception.class)
    public void start() {
        log.info(" *** start RoleUserTask缓存 *** ");

        StringBuffer sb = new StringBuffer();
        //只拿运维人员
        sb.append(" SELECT id as 'user_id' from itsm_uc_user where ACCOUNT != 'dsadmin' and delete_flag = 0 ");

        Object roleId = getSingleObj(jdbcTemplateHsms," SELECT id from itsm_uc_role WHERE rolecode = 'first-line support' ");

        List list = jdbcTemplateMdv2.queryForList(sb.toString());

        FieldMapper mapper = new FieldMapper();
        FieldMapper userMapper = userTask.loadCache();
        mapper.addOperationAdd("role_id", Long.valueOf(roleId.toString()));
        mapper.addOperationReplace("user_id", userMapper.getIdCache());
        mapper.trans2JdbcRow(list);

        JdbcUtil jdbcUtil = new JdbcUtil(jdbcTemplateHsms);
        jdbcUtil.batchPageInsert("itsm_uc_user_role", mapper.getRows());

        //clear释放内存
        mapper.clear();
        userMapper.clear();
    }

    @Override
    public FieldMapper loadCache() {
        log.info(" *** 加载RoleUserTask缓存 *** ");

        return null;
    }
}
