package com.dashitech.migration.task.uc;

import com.dashitech.migration.BaseTask;
import com.dashitech.migration.SqlTask;
import com.dashitech.migration.core.FieldMapper;
import com.dashitech.migration.util.JdbcUtil;
import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;
import org.springframework.transaction.annotation.Transactional;

import java.util.List;

/**
 * Created by CX on 2024/10/10.
 */
@Component
public class UserGroupTask extends BaseTask {

    @Autowired
    SqlTask groupTask;

    @Autowired
    SqlTask userTask;

    public static Log log = LogFactory.getLog(UserGroupTask.class);

    @Override
    @Transactional(rollbackFor = Exception.class)
    public void start() {
        log.info(" *** UserGroupTask 转换 开始 *** ");

        StringBuffer sb = new StringBuffer();
        //只拿运维人员
        sb.append(" select group_id,user_id from itsm_uc_user_group ");

        List list = jdbcTemplateMdv2.queryForList(sb.toString());

        FieldMapper mapper = new FieldMapper();
        FieldMapper groupMapper = groupTask.loadCache();
        FieldMapper userMapper = userTask.loadCache();

        mapper.addOperationReplace("group_id", groupMapper.getIdCache());
        mapper.addOperationReplace("user_id", userMapper.getIdCache());
        mapper.trans2JdbcRow(list);

        JdbcUtil jdbcUtil = new JdbcUtil(jdbcTemplateHsms);
        jdbcUtil.batchPageInsert("itsm_uc_user_group", mapper.getRows());

        //clear释放内存
        mapper.clear();
        groupMapper.clear();
        userMapper.clear();
    }

    @Override
    public FieldMapper loadCache() {
        log.info(" *** UserGroupTask loadCache 开始 *** ");

        return null;
    }
}
