package com.dashitech.migration.task.workhour;

import com.dashitech.migration.BaseTask;
import com.dashitech.migration.core.FieldMapper;
import com.dashitech.migration.task.uc.HospitalTask;
import com.dashitech.migration.util.JdbcUtil;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;
import org.springframework.transaction.annotation.Transactional;

import java.util.List;
import java.util.Map;

/**
 * @author song
 * @date 2024年10月12日
 */
@Component
public class WorkHourManagementTask extends BaseTask {

    @Autowired
    private HospitalTask hospitalTask;

    @Override
    @Transactional(rollbackFor = Exception.class)
    public void start() {
        StringBuffer sql = new StringBuffer("SELECT id,version,work_unit,work_name,tree_level,parent,wage,");
        sql.append("work_hour_num as work_hour,duty as hos_id,delete_flag FROM itsm_work_hour_management ");
        List<Map<String, Object>> workHourList = jdbcTemplateMdv2.queryForList(sql.toString());

        FieldMapper mapper = new FieldMapper();
        mapper.addOperationReplace("hos_id", hospitalTask.loadCache().getIdCache());
        mapper.trans2JdbcRow(workHourList);

        JdbcUtil jdbcUtil = new JdbcUtil(jdbcTemplateHsms);
        jdbcUtil.batchPageInsert("itsm_itsm_work_hour_management", mapper.getRows());

        mapper.clear();
    }

    @Override
    public FieldMapper loadCache() {
        return null;
    }
}
