package com.dashitech.migration.util;

import java.util.ArrayList;
import java.util.LinkedHashMap;
import java.util.List;
import java.util.Map;

/**
 * JdbcUtil工具类使用，表示一行数据的新增或者修改
 * Created by CX on 2020/10/14.
 */
public class JdbcRow {

    private Map<String, Object> row = new LinkedHashMap<String, Object>();
    private List params = new ArrayList();
    private StringBuffer where = new StringBuffer(" where 1 = 1 ");

    public static JdbcRow newInstance() {
        return new JdbcRow();
    }

    /**
     * 设置行的数据项
     * @param field 数据库字段名称
     * @param value 需存储数据
     */
    public JdbcRow setAttribute(String field,Object value) {
        row.put(field, value);
        return this;
    }

    /**
     * 设置简单等于的参数，这样就不用追加参数了
     * @param field 数据库表的字段名称
     * @param value 匹配数据
     */
    public JdbcRow setWhere(String field,Object value) {
        where.append(" and ");
        where.append(field);
        where.append(" = ? ");
        params.add(value);
        return this;
    }

    /**
     * 自定义查询语句，自己选择，怎么拼接sql。可以是 and ,or , = ,in ,BETWEEN ,order by ,group by 等任何语句
     */
    public JdbcRow setWhere(String condition) {
        where.append(" ");
        where.append(condition);
        where.append(" ");
        return this;
    }

    /**
     * 手动追加参数
     */
    public JdbcRow setParams(String value) {
        params.add(value);
        return this;
    }

    public Map<String, Object> getRow() {
        return row;
    }

    public void setRow(Map<String, Object> row) {
        this.row = row;
    }

    public String getWhere() {
        return where.toString();
    }

    public List getParams() {
        return params;
    }
}
