package com.dashitech.utils;

import java.sql.*;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

/**
 * Created by xuweihua on 2021/4/1.
 */
public class OracleConn {
    private static String jdbc = PropertiesUtil.getProperty("oracle.conn.jdbc");
    private static String user = PropertiesUtil.getProperty("oracle.user");
    private static String pwd = PropertiesUtil.getProperty("oracle.password");

    private static String user2 = PropertiesUtil.getProperty("oracle.user2");
    private static String pwd2 = PropertiesUtil.getProperty("oracle.password2");

    private static String jdbc2 = PropertiesUtil.getProperty("oracle.conn.jdbc2");
    private static String jdbc3 = PropertiesUtil.getProperty("oracle.conn.jdbc3");

    private static String user3 = PropertiesUtil.getProperty("oracle.user3");
    private static String pwd3 = PropertiesUtil.getProperty("oracle.password3");

    private static Connection  con = null;// 创建一个数据库连接
    private static Connection  con2 = null;// 创建一个数据库连接
    private static Connection  con3 = null;// 创建一个数据库连接
    private static Connection  con4 = null;// 创建一个数据库连接


    public List<Map<String, Object>> getOracleDataList(String sql) {
        List<Map<String, Object>> list = new ArrayList<>();
        PreparedStatement pre = null;// 创建预编译语句对象，一般都是用这个而不用Statement
        ResultSet result = null;// 创建一个结果集对象
        try {
            if(con == null) {
                Class.forName("oracle.jdbc.driver.OracleDriver");// 加载Oracle驱动程序
                //System.out.println("开始尝试连接数据库！");
                con = DriverManager.getConnection(jdbc, user, pwd);// 获取连接
                //System.out.println("连接成功！");
            }
            pre = con.prepareStatement(sql);
            result = pre.executeQuery();
            ResultSetMetaData md = result.getMetaData();// 获得结果集结构信息（元数据）
            int columnCount = md.getColumnCount();// ResultSet列数
            // ResultSet转List<Map>数据结构
            // next用于移动到ResultSet的下一行，使下一行成为当前行
            while (result.next()) {
                Map<String, Object> map = new HashMap<>();
                for (int i = 1; i <= columnCount; i++) {// 遍历获取对当前行的每一列的键值对，put到map中
                    // rs.getObject(i) 获得当前行某一列字段的值
                    map.put(md.getColumnName(i).toLowerCase(), result.getObject(i));
                }
                list.add(map);
            }
            return list;
        }catch (Exception e) {
            e.printStackTrace();
            try {
                if (con != null) { // 使用单例模式不关闭连接
                    con.close();
                    con = null;
                    System.out.println("关闭数据库连接！");
                }
            }catch (Exception ex){
                ex.printStackTrace();
            }
        } finally {
            try {
                // 逐一将上面的几个对象关闭，因为不关闭的话会影响性能、并且占用资源
                // 注意关闭的顺序，最后使用的最先关闭
                if (result != null) {
                    result.close();
                }
                if (pre != null) {
                    pre.close();
                }
                if (con != null) { // 使用单例模式不关闭连接
                    // con.close();
                  //  System.out.println("关闭数据库连接！");
                }
            } catch (Exception e) {
                e.printStackTrace();
            }
        }
        return list;
    }

    /**
     * 手术专用
     * @param sql
     * @return
     */
    public List<Map<String, Object>> getSurgeryOracleDataList(String sql) {
        List<Map<String, Object>> list = new ArrayList<>();
        PreparedStatement pre = null;// 创建预编译语句对象，一般都是用这个而不用Statement
        ResultSet result = null;// 创建一个结果集对象
        try {
            if(con2 == null) {
                Class.forName("oracle.jdbc.driver.OracleDriver");// 加载Oracle驱动程序
                //System.out.println("开始尝试连接数据库！");
                con2 = DriverManager.getConnection(jdbc, user2, pwd2);// 获取连接
                //System.out.println("连接成功！");
            }
            pre = con2.prepareStatement(sql);
            result = pre.executeQuery();
            ResultSetMetaData md = result.getMetaData();// 获得结果集结构信息（元数据）
            int columnCount = md.getColumnCount();// ResultSet列数
            // ResultSet转List<Map>数据结构
            // next用于移动到ResultSet的下一行，使下一行成为当前行
            while (result.next()) {
                Map<String, Object> map = new HashMap<>();
                for (int i = 1; i <= columnCount; i++) {// 遍历获取对当前行的每一列的键值对，put到map中
                    // rs.getObject(i) 获得当前行某一列字段的值
                    map.put(md.getColumnName(i).toLowerCase(), result.getObject(i));
                }
                list.add(map);
            }
            return list;
        }catch (Exception e) {
            e.printStackTrace();
            try {
                if (con2 != null) { // 使用单例模式不关闭连接
                    con2.close();
                    con2 = null;
                    System.out.println("关闭数据库连接！");
                }
            }catch (Exception ex){
                ex.printStackTrace();
            }
        } finally {
            try {
                // 逐一将上面的几个对象关闭，因为不关闭的话会影响性能、并且占用资源
                // 注意关闭的顺序，最后使用的最先关闭
                if (result != null) {
                    result.close();
                }
                if (pre != null) {
                    pre.close();
                }
                if (con2 != null) { // 使用单例模式不关闭连接
                    // con.close();
                    //  System.out.println("关闭数据库连接！");
                }
            } catch (Exception e) {
                e.printStackTrace();
            }
        }
        return list;
    }

    /**
     * 血制品
     * @author song
     * @date 2024/08/06
     * @param sql
     * @return java.util.List<java.util.Map<java.lang.String,java.lang.Object>>
     */
    public List<Map<String, Object>> getBloodOracleDataList(String sql) {
        List<Map<String, Object>> list = new ArrayList<>();
        PreparedStatement pre = null;// 创建预编译语句对象，一般都是用这个而不用Statement
        ResultSet result = null;// 创建一个结果集对象
        try {
            if(con3 == null) {
                Class.forName("oracle.jdbc.driver.OracleDriver");// 加载Oracle驱动程序
                con3 = DriverManager.getConnection(jdbc2, user3, pwd3);// 获取连接
            }
            pre = con3.prepareStatement(sql);
            result = pre.executeQuery();
            ResultSetMetaData md = result.getMetaData();// 获得结果集结构信息（元数据）
            int columnCount = md.getColumnCount();// ResultSet列数
            // ResultSet转List<Map>数据结构
            // next用于移动到ResultSet的下一行，使下一行成为当前行
            while (result.next()) {
                Map<String, Object> map = new HashMap<>();
                for (int i = 1; i <= columnCount; i++) {// 遍历获取对当前行的每一列的键值对，put到map中
                    // rs.getObject(i) 获得当前行某一列字段的值
                    map.put(md.getColumnName(i).toLowerCase(), result.getObject(i));
                }
                list.add(map);
            }
            return list;
        }catch (Exception e) {
            e.printStackTrace();
            try {
                if (con3 != null) { // 使用单例模式不关闭连接
                    con3.close();
                    con3 = null;
                    System.out.println("关闭数据库连接！");
                }
            }catch (Exception ex){
                ex.printStackTrace();
            }
        } finally {
            try {
                // 逐一将上面的几个对象关闭，因为不关闭的话会影响性能、并且占用资源
                // 注意关闭的顺序，最后使用的最先关闭
                if (result != null) {
                    result.close();
                }
                if (pre != null) {
                    pre.close();
                }
            } catch (Exception e) {
                e.printStackTrace();
            }
        }
        return list;
    }

    /**
     * 标本
     * @author song
     * @date 2024/08/06
     * @param sql
     * @return java.util.List<java.util.Map<java.lang.String,java.lang.Object>>
     */
    public List<Map<String, Object>> getSpecimenOracleDataList(String sql) {
        List<Map<String, Object>> list = new ArrayList<>();
        PreparedStatement pre = null;// 创建预编译语句对象，一般都是用这个而不用Statement
        ResultSet result = null;// 创建一个结果集对象
        try {
            if(con4 == null) {
                Class.forName("oracle.jdbc.driver.OracleDriver");// 加载Oracle驱动程序
                con4 = DriverManager.getConnection(jdbc3, user3, pwd3);// 获取连接
            }
            pre = con4.prepareStatement(sql);
            result = pre.executeQuery();
            ResultSetMetaData md = result.getMetaData();// 获得结果集结构信息（元数据）
            int columnCount = md.getColumnCount();// ResultSet列数
            // ResultSet转List<Map>数据结构
            // next用于移动到ResultSet的下一行，使下一行成为当前行
            while (result.next()) {
                Map<String, Object> map = new HashMap<>();
                for (int i = 1; i <= columnCount; i++) {// 遍历获取对当前行的每一列的键值对，put到map中
                    // rs.getObject(i) 获得当前行某一列字段的值
                    map.put(md.getColumnName(i).toLowerCase(), result.getObject(i));
                }
                list.add(map);
            }
            return list;
        }catch (Exception e) {
            e.printStackTrace();
            try {
                if (con4 != null) { // 使用单例模式不关闭连接
                    con4.close();
                    con4 = null;
                    System.out.println("关闭数据库连接！");
                }
            }catch (Exception ex){
                ex.printStackTrace();
            }
        } finally {
            try {
                // 逐一将上面的几个对象关闭，因为不关闭的话会影响性能、并且占用资源
                // 注意关闭的顺序，最后使用的最先关闭
                if (result != null) {
                    result.close();
                }
                if (pre != null) {
                    pre.close();
                }
            } catch (Exception e) {
                e.printStackTrace();
            }
        }
        return list;
    }


}
